Index: GTP-Internal/trunk/Webpage/NOF/gtp_webpage/gtp_webpage_html/html/left_faq.html
===================================================================
--- GTP-Internal/trunk/Webpage/NOF/gtp_webpage/gtp_webpage_html/html/left_faq.html	(revision 1515)
+++ GTP-Internal/trunk/Webpage/NOF/gtp_webpage/gtp_webpage_html/html/left_faq.html	(revision 1538)
@@ -28,44 +28,44 @@
     <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=171 NOF=LY>
         <TR VALIGN=TOP ALIGN=LEFT>
-            <TD HEIGHT=532 WIDTH=171>
+            <TD HEIGHT=350 WIDTH=171>
                 <TABLE ID="NavigationBar1" BORDER=0 CELLSPACING=0 CELLPADDING=0 NOF=NB_UYVPNY120 WIDTH=171>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=171 HEIGHT=38><A HREF="../html/overview.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton1','',0);F_roll('NavigationButton1',1)" onMouseOut="F_roll('NavigationButton1',0)"><IMG ID="NavigationButton1" NAME="NavigationButton1" HEIGHT=38 WIDTH=171 SRC="../assets/images/autogen/Overview_Nmenu_base.gif" onLoad="F_loadRollover(this,'Overview_NRmenu_base.jpg',0)" BORDER=0 ALT="Overview" TITLE="Overview"></A></TD>
+                        <TD WIDTH=171 HEIGHT=24><A HREF="../html/overview.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton1','',0);F_roll('NavigationButton1',1)" onMouseOut="F_roll('NavigationButton1',0)"><IMG ID="NavigationButton1" NAME="NavigationButton1" HEIGHT=24 WIDTH=171 SRC="../assets/images/autogen/Overview_Nmenu_base.gif" onLoad="F_loadRollover(this,'Overview_NRmenu_base.jpg',0)" BORDER=0 ALT="Overview" TITLE="Overview"></A></TD>
                     </TR>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=171 HEIGHT=38><A HREF="../html/technology.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton2','',0);F_roll('NavigationButton2',1)" onMouseOut="F_roll('NavigationButton2',0)"><IMG ID="NavigationButton2" NAME="NavigationButton2" HEIGHT=38 WIDTH=171 SRC="../assets/images/autogen/Technology_Nmenu_base.gif" onLoad="F_loadRollover(this,'Technology_NRmenu_base.jpg',0)" BORDER=0 ALT="Technology" TITLE="Technology"></A></TD>
+                        <TD WIDTH=171 HEIGHT=24><A HREF="../html/technology.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton2','',0);F_roll('NavigationButton2',1)" onMouseOut="F_roll('NavigationButton2',0)"><IMG ID="NavigationButton2" NAME="NavigationButton2" HEIGHT=24 WIDTH=171 SRC="../assets/images/autogen/Technology_Nmenu_base.gif" onLoad="F_loadRollover(this,'Technology_NRmenu_base.jpg',0)" BORDER=0 ALT="Technology" TITLE="Technology"></A></TD>
                     </TR>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=171 HEIGHT=38><A HREF="../html/join_the_gtp__.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton3','',0);F_roll('NavigationButton3',1)" onMouseOut="F_roll('NavigationButton3',0)"><IMG ID="NavigationButton3" NAME="NavigationButton3" HEIGHT=38 WIDTH=171 SRC="../assets/images/autogen/JOIN_the_GTP_____Nmenu_base.gif" onLoad="F_loadRollover(this,'JOIN_the_GTP_____NRmenu_base.jpg',0)" BORDER=0 ALT="JOIN the GTP !!!" TITLE="JOIN the GTP !!!"></A></TD>
+                        <TD WIDTH=171 HEIGHT=24><A HREF="../html/join_the_gtp__.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton3','',0);F_roll('NavigationButton3',1)" onMouseOut="F_roll('NavigationButton3',0)"><IMG ID="NavigationButton3" NAME="NavigationButton3" HEIGHT=24 WIDTH=171 SRC="../assets/images/autogen/JOIN_the_GTP_____Nmenu_base.gif" onLoad="F_loadRollover(this,'JOIN_the_GTP_____NRmenu_base.jpg',0)" BORDER=0 ALT="JOIN the GTP !!!" TITLE="JOIN the GTP !!!"></A></TD>
                     </TR>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=171 HEIGHT=38><A HREF="../html/demos___videos.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton4','',0);F_roll('NavigationButton4',1)" onMouseOut="F_roll('NavigationButton4',0)"><IMG ID="NavigationButton4" NAME="NavigationButton4" HEIGHT=38 WIDTH=171 SRC="../assets/images/autogen/DEMOS___VIDEOS_Nmenu_base.gif" onLoad="F_loadRollover(this,'DEMOS___VIDEOS_NRmenu_base.jpg',0)" BORDER=0 ALT="DEMOS / VIDEOS" TITLE="DEMOS / VIDEOS"></A></TD>
+                        <TD WIDTH=171 HEIGHT=24><A HREF="../html/demos___videos.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton4','',0);F_roll('NavigationButton4',1)" onMouseOut="F_roll('NavigationButton4',0)"><IMG ID="NavigationButton4" NAME="NavigationButton4" HEIGHT=24 WIDTH=171 SRC="../assets/images/autogen/DEMOS___VIDEOS_Nmenu_base.gif" onLoad="F_loadRollover(this,'DEMOS___VIDEOS_NRmenu_base.jpg',0)" BORDER=0 ALT="DEMOS / VIDEOS" TITLE="DEMOS / VIDEOS"></A></TD>
                     </TR>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=171 HEIGHT=38><A HREF="../html/gtp_members.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton5','',0);F_roll('NavigationButton5',1)" onMouseOut="F_roll('NavigationButton5',0)"><IMG ID="NavigationButton5" NAME="NavigationButton5" HEIGHT=38 WIDTH=171 SRC="../assets/images/autogen/GTP_Members_Nmenu_base.gif" onLoad="F_loadRollover(this,'GTP_Members_NRmenu_base.jpg',0)" BORDER=0 ALT="GTP Members" TITLE="GTP Members"></A></TD>
+                        <TD WIDTH=171 HEIGHT=24><A HREF="../html/gtp_members.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton5','',0);F_roll('NavigationButton5',1)" onMouseOut="F_roll('NavigationButton5',0)"><IMG ID="NavigationButton5" NAME="NavigationButton5" HEIGHT=24 WIDTH=171 SRC="../assets/images/autogen/GTP_Members_Nmenu_base.gif" onLoad="F_loadRollover(this,'GTP_Members_NRmenu_base.jpg',0)" BORDER=0 ALT="GTP Members" TITLE="GTP Members"></A></TD>
                     </TR>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=171 HEIGHT=38><A HREF="../html/gtp_sig.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton6','',0);F_roll('NavigationButton6',1)" onMouseOut="F_roll('NavigationButton6',0)"><IMG ID="NavigationButton6" NAME="NavigationButton6" HEIGHT=38 WIDTH=171 SRC="../assets/images/autogen/GTP_SIG_Nmenu_base.gif" onLoad="F_loadRollover(this,'GTP_SIG_NRmenu_base.jpg',0)" BORDER=0 ALT="GTP SIG" TITLE="GTP SIG"></A></TD>
+                        <TD WIDTH=171 HEIGHT=24><A HREF="../html/gtp_sig.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton6','',0);F_roll('NavigationButton6',1)" onMouseOut="F_roll('NavigationButton6',0)"><IMG ID="NavigationButton6" NAME="NavigationButton6" HEIGHT=24 WIDTH=171 SRC="../assets/images/autogen/GTP_SIG_Nmenu_base.gif" onLoad="F_loadRollover(this,'GTP_SIG_NRmenu_base.jpg',0)" BORDER=0 ALT="GTP SIG" TITLE="GTP SIG"></A></TD>
                     </TR>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=171 HEIGHT=38><A HREF="../html/gtp_partners.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton7','',0);F_roll('NavigationButton7',1)" onMouseOut="F_roll('NavigationButton7',0)"><IMG ID="NavigationButton7" NAME="NavigationButton7" HEIGHT=38 WIDTH=171 SRC="../assets/images/autogen/GTP_Partners_Nmenu_base.gif" onLoad="F_loadRollover(this,'GTP_Partners_NRmenu_base.jpg',0)" BORDER=0 ALT="GTP Partners" TITLE="GTP Partners"></A></TD>
+                        <TD WIDTH=171 HEIGHT=24><A HREF="../html/gtp_partners.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton7','',0);F_roll('NavigationButton7',1)" onMouseOut="F_roll('NavigationButton7',0)"><IMG ID="NavigationButton7" NAME="NavigationButton7" HEIGHT=24 WIDTH=171 SRC="../assets/images/autogen/GTP_Partners_Nmenu_base.gif" onLoad="F_loadRollover(this,'GTP_Partners_NRmenu_base.jpg',0)" BORDER=0 ALT="GTP Partners" TITLE="GTP Partners"></A></TD>
                     </TR>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=171 HEIGHT=38><A HREF="../html/news.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton8','',0);F_roll('NavigationButton8',1)" onMouseOut="F_roll('NavigationButton8',0)"><IMG ID="NavigationButton8" NAME="NavigationButton8" HEIGHT=38 WIDTH=171 SRC="../assets/images/autogen/News_Nmenu_base.gif" onLoad="F_loadRollover(this,'News_NRmenu_base.jpg',0)" BORDER=0 ALT="News" TITLE="News"></A></TD>
+                        <TD WIDTH=171 HEIGHT=24><A HREF="../html/news.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton8','',0);F_roll('NavigationButton8',1)" onMouseOut="F_roll('NavigationButton8',0)"><IMG ID="NavigationButton8" NAME="NavigationButton8" HEIGHT=24 WIDTH=171 SRC="../assets/images/autogen/News_Nmenu_base.gif" onLoad="F_loadRollover(this,'News_NRmenu_base.jpg',0)" BORDER=0 ALT="News" TITLE="News"></A></TD>
                     </TR>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=171 HEIGHT=38><A HREF="../html/aaa.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton9','',0);F_roll('NavigationButton9',1)" onMouseOut="F_roll('NavigationButton9',0)"><IMG ID="NavigationButton9" NAME="NavigationButton9" HEIGHT=38 WIDTH=171 SRC="../assets/images/autogen/Publications_Nmenu_base.gif" onLoad="F_loadRollover(this,'Publications_NRmenu_base.jpg',0)" BORDER=0 ALT="Publications" TITLE="Publications"></A></TD>
+                        <TD WIDTH=171 HEIGHT=24><A HREF="../html/aaa.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton9','',0);F_roll('NavigationButton9',1)" onMouseOut="F_roll('NavigationButton9',0)"><IMG ID="NavigationButton9" NAME="NavigationButton9" HEIGHT=24 WIDTH=171 SRC="../assets/images/autogen/Publications_Nmenu_base.gif" onLoad="F_loadRollover(this,'Publications_NRmenu_base.jpg',0)" BORDER=0 ALT="Publications" TITLE="Publications"></A></TD>
                     </TR>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=171 HEIGHT=38><A HREF="../html/press.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton10','',0);F_roll('NavigationButton10',1)" onMouseOut="F_roll('NavigationButton10',0)"><IMG ID="NavigationButton10" NAME="NavigationButton10" HEIGHT=38 WIDTH=171 SRC="../assets/images/autogen/Press_Nmenu_base.gif" onLoad="F_loadRollover(this,'Press_NRmenu_base.jpg',0)" BORDER=0 ALT="Press" TITLE="Press"></A></TD>
+                        <TD WIDTH=171 HEIGHT=24><A HREF="../html/press.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton10','',0);F_roll('NavigationButton10',1)" onMouseOut="F_roll('NavigationButton10',0)"><IMG ID="NavigationButton10" NAME="NavigationButton10" HEIGHT=24 WIDTH=171 SRC="../assets/images/autogen/Press_Nmenu_base.gif" onLoad="F_loadRollover(this,'Press_NRmenu_base.jpg',0)" BORDER=0 ALT="Press" TITLE="Press"></A></TD>
                     </TR>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=171 HEIGHT=38><A HREF="../html/internal.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton11','',0);F_roll('NavigationButton11',1)" onMouseOut="F_roll('NavigationButton11',0)"><IMG ID="NavigationButton11" NAME="NavigationButton11" HEIGHT=38 WIDTH=171 SRC="../assets/images/autogen/Internal_Nmenu_base.gif" onLoad="F_loadRollover(this,'Internal_NRmenu_base.jpg',0)" BORDER=0 ALT="Internal" TITLE="Internal"></A></TD>
+                        <TD WIDTH=171 HEIGHT=24><A HREF="../html/internal.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton11','',0);F_roll('NavigationButton11',1)" onMouseOut="F_roll('NavigationButton11',0)"><IMG ID="NavigationButton11" NAME="NavigationButton11" HEIGHT=24 WIDTH=171 SRC="../assets/images/autogen/Internal_Nmenu_base.gif" onLoad="F_loadRollover(this,'Internal_NRmenu_base.jpg',0)" BORDER=0 ALT="Internal" TITLE="Internal"></A></TD>
                     </TR>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=171 HEIGHT=38><A HREF="../html/downloads.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton12','',0);F_roll('NavigationButton12',1)" onMouseOut="F_roll('NavigationButton12',0)"><IMG ID="NavigationButton12" NAME="NavigationButton12" HEIGHT=38 WIDTH=171 SRC="../assets/images/autogen/Downloads_Nmenu_base.gif" onLoad="F_loadRollover(this,'Downloads_NRmenu_base.jpg',0)" BORDER=0 ALT="Downloads" TITLE="Downloads"></A></TD>
+                        <TD WIDTH=171 HEIGHT=24><A HREF="../html/downloads.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton12','',0);F_roll('NavigationButton12',1)" onMouseOut="F_roll('NavigationButton12',0)"><IMG ID="NavigationButton12" NAME="NavigationButton12" HEIGHT=24 WIDTH=171 SRC="../assets/images/autogen/Downloads_Nmenu_base.gif" onLoad="F_loadRollover(this,'Downloads_NRmenu_base.jpg',0)" BORDER=0 ALT="Downloads" TITLE="Downloads"></A></TD>
                     </TR>
                     <TR VALIGN=TOP ALIGN=LEFT>
-                        <TD WIDTH=171 HEIGHT=38><A HREF="../html/links.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton13','',0);F_roll('NavigationButton13',1)" onMouseOut="F_roll('NavigationButton13',0)"><IMG ID="NavigationButton13" NAME="NavigationButton13" HEIGHT=38 WIDTH=171 SRC="../assets/images/autogen/Links_Nmenu_base.gif" onLoad="F_loadRollover(this,'Links_NRmenu_base.jpg',0)" BORDER=0 ALT="Links" TITLE="Links"></A></TD>
+                        <TD WIDTH=171 HEIGHT=24><A HREF="../html/links.html" style="cursor:hand; text-decoration:none;" onMouseOver="F_loadRollover('NavigationButton13','',0);F_roll('NavigationButton13',1)" onMouseOut="F_roll('NavigationButton13',0)"><IMG ID="NavigationButton13" NAME="NavigationButton13" HEIGHT=24 WIDTH=171 SRC="../assets/images/autogen/Links_Nmenu_base.gif" onLoad="F_loadRollover(this,'Links_NRmenu_base.jpg',0)" BORDER=0 ALT="Links" TITLE="Links"></A></TD>
                     </TR>
                     <TR VALIGN=TOP ALIGN=LEFT>