Index: GTP-Internal/trunk/Webpage/NOF/gtp_webpage/gtp_webpage_html/html/body_demos___videos.html
===================================================================
--- GTP-Internal/trunk/Webpage/NOF/gtp_webpage/gtp_webpage_html/html/body_demos___videos.html	(revision 1515)
+++ GTP-Internal/trunk/Webpage/NOF/gtp_webpage/gtp_webpage_html/html/body_demos___videos.html	(revision 1544)
@@ -12,5 +12,5 @@
 </STYLE>
 </HEAD>
-<BODY NOF="(MB=(DefaultMasterBorder, 121, 127, 171, 0), L=(DemosVideosLayout, 727, 2254))" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
+<BODY NOF="(MB=(DefaultMasterBorder, 121, 127, 171, 0), L=(DemosVideosLayout, 727, 2868))" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
     <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=631 NOF=LY>
         <TR VALIGN=TOP ALIGN=LEFT>
@@ -34,6 +34,54 @@
             <TD WIDTH=600>
                 <TABLE ID="Tabelle3" BORDER=0 CELLSPACING=2 CELLPADDING=2 WIDTH="100%">
-                    <TR>
+                    <TR HEIGHT=100>
                         <TD WIDTH=102>
+                            <P><A HREF="http://www.gametools.org/videos/cargamesmall.avi"><IMG ID="Picture459" HEIGHT=100 WIDTH=100 SRC="../assets/images/cargamesmall.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="cargamesmall" TITLE="cargamesmall"></A></P>
+                        </TD>
+                        <TD VALIGN=TOP>
+                            <P><SPAN STYLE="font-size: 8pt;">Video capture of the demo game showed in EG06. The demo demonstrates raytraced reflections, refractions and caustics with depth impostors; diffuse environment lighting; spherical billboards and glow. The game is implemented in OGRE.</SPAN></P>
+                        </TD>
+                    </TR>
+                    <TR HEIGHT=100>
+                        <TD>
+                            <P><A HREF="http://www.gametools.org/videos/Explosionsmall.avi"><IMG ID="Picture460" HEIGHT=100 WIDTH=100 SRC="../assets/images/Explosionsmall.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="Explosionsmall" TITLE="Explosionsmall"></A></P>
+                        </TD>
+                        <TD VALIGN=TOP>
+                            <P><SPAN STYLE="font-size: 8pt;">Video capture of the explosion demo. This movie is longer than the one already on the site. It also shows how does the change of different parameters influence the final image.</SPAN></P>
+                        </TD>
+                    </TR>
+                    <TR HEIGHT=100>
+                        <TD>
+                            <P><A HREF="http://www.gametools.org/videos/hpssmall.avi"><IMG ID="Picture461" HEIGHT=100 WIDTH=100 SRC="../assets/images/hpssmall.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="hpssmall" TITLE="hpssmall"></A></P>
+                        </TD>
+                        <TD VALIGN=TOP>
+                            <P><SPAN STYLE="font-size: 8pt;">Video capture of our latest OGRE demo which shows hierarchical particle systems and light volumes. It shows a particle system of a particle system. This way the number of particles can be reduced significantly. It also demonstrates dynamic lighting of this volumetric medium. The method also eliminates billboard clipping artifacts.</SPAN></P>
+                        </TD>
+                    </TR>
+                    <TR HEIGHT=100>
+                        <TD>
+                            <P><A HREF="http://www.gametools.org/videos/pathmap4avi"><IMG ID="Picture462" HEIGHT=100 WIDTH=100 SRC="../assets/images/pathmap4.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="pathmap4" TITLE="pathmap4"></A></P>
+                        </TD>
+                        <TD VALIGN=TOP>
+                            <P><SPAN STYLE="font-size: 8pt;">It demostrates our demo using precomputed radiance maps.</SPAN></P>
+                        </TD>
+                    </TR>
+                    <TR HEIGHT=100>
+                        <TD>
+                            <P><A HREF="http://www.gametools.org/videos/tatu3.avi"><IMG ID="Picture463" HEIGHT=100 WIDTH=100 SRC="../assets/images/tatu3.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="tatu3" TITLE="tatu3"></A></P>
+                        </TD>
+                        <TD VALIGN=TOP>
+                            <P><SPAN STYLE="font-size: 8pt;">Another capture of the precomputed radiance maps demo.</SPAN></P>
+                        </TD>
+                    </TR>
+                    <TR HEIGHT=100>
+                        <TD>
+                            <P><A HREF="http://www.gametools.org/videos/Raytracesmall.avi"><IMG ID="Picture464" HEIGHT=100 WIDTH=100 SRC="../assets/images/Raytracesmall.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="Raytracesmall" TITLE="Raytracesmall"></A></P>
+                        </TD>
+                        <TD VALIGN=TOP>
+                            <P><SPAN STYLE="font-size: 8pt;">Video capture of our OGRE demo, demonstrating caustics, reflections and refractions.</SPAN></P>
+                        </TD>
+                    </TR>
+                    <TR HEIGHT=100>
+                        <TD>
                             <P><A HREF="../html/jungle_rumble.html"><IMG ID="Picture457" HEIGHT=100 WIDTH=100 SRC="../assets/images/jungle_rumble_icon1.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="jungle_rumble_icon1" TITLE="jungle_rumble_icon1"></A></P>
                         </TD>
@@ -42,5 +90,5 @@
                         </TD>
                     </TR>
-                    <TR>
+                    <TR HEIGHT=100>
                         <TD>
                             <P><A HREF="http://www.gametools.org/videos/trees.avi"><IMG ID="Picture456" HEIGHT=100 WIDTH=100 SRC="../assets/images/trees.jpg" VSPACE=0 HSPACE=0 ALIGN="TOP" BORDER=0 ALT="trees" TITLE="trees"></A></P>